import jp.jig.jiglet.*;

public class TVSize extends Jiglet {
	static final String URL = "http://www.google.com/search?q=" + encodeURL("eȓ傫") + "&lr=";
	static final int URL_ENCODE = ENCODE_UTF8;

	public void main() {
		setMenu(new String[] { "eȓ傫", "wv" }, new String[] { "\"eȓ傫\"Ō܂", "g\܂" });
		setSoftLabel("I");
		
		load();
		
		boolean duty = false;
		for (;;) {
			repaint();
			sleep(10);
			
			int key = getKey();
			if (key == KEY_IAPP || key == KEY_SOFT) {
				return;
			}
			if (key == KEY_UP) {
				if (inch[cursor] < 255) {
					inch[cursor]++;
					duty = true;
				}
			} else if (key == KEY_DOWN) {
				if (inch[cursor] > 0) {
					inch[cursor]--;
					duty = true;
				}
			} else if (key == KEY_LEFT || key == KEY_RIGHT || key == KEY_SELECT) {
				cursor = 1 - cursor;
			}
			if (duty && getKeypadState() == 0) {
				save();
				duty = false;
			}
			
			if (key > KEY_LAST) {
				int evt = key & 0xffff0000;
				int val = key & 0xffff;
				if (evt == EVENT_MENU) {
					if (val == 0) {
						launch(URL, URL_ENCODE, LAUNCH_KEEP_ALIVE);
					} else if (val == 1) {
						showDialog("E܂͌L[ő傫ύXerIA㉺Ńeȓ傫𒲐", DIALOG_TYPE_OK);
					}
				}
			}
		}
	}
	
	int cursor = 0;
	int[] inch = new int[2];
	static final int[] RATIO = {
		4, 3, 5,
		1600, 900, 1836,
	};
	static final String[] LABEL = {
		" 4:3",
		"16:9",
	};
	//  4:3 = 5
	// 16:9 = 18.358
	// 1inch = 2.54cm
	
	int fh, fw;
	public void paint(boolean allDrawFlag) {
		setFont(FONT_SMALL);
		if (fh == 0 || fw == 0) {
			fh = getFontHeight();
			fw = stringWidth("");
		}
		setColor(255, 255, 255);
		fillRect(0, 0, DW, DH);
		
		setColor(0, 0, 0);
		
		int[] w = new int[2];
		int[] h = new int[2];
		for (int i = 0; i < 2; i++) {
			int rw = RATIO[i * 3];
			int rh = RATIO[i * 3 + 1];
			int rl = RATIO[i * 3 + 2];
			w[i] = inch[i] * 254 * rw / rl / 100;
			h[i] = inch[i] * 254 * rh / rl / 100;
		}
		
		int base = DH - (fh + fh / 2) * 5;
		int max = DW * 8 / 10;
		int off = DW / 10;
		for (int i = 0; i < 2; i++) {
			int rw = w[i] * max / 200;
			int rh = h[i] * max / 200;
			setColor(0, 0, 0);
			drawRect(off, base - rh, rw, rh);
			if (cursor == i) {
				setColor(255, 0, 0);
			}
			drawLine(off, base, off + rw, base - rh);
		}
		
		for (int i = 0; i < 2; i++) {
			int x = off + fw * 10 * i;
			int y = base + fh + fh / 2;
			int fs = fh + fh / 8;
			setColor(0, 0, 0);
			drawString(LABEL[i], x, y);
			if (cursor == i) {
				setColor(255, 0, 0);
			}
			drawString(fix(inch[i]) + "^", x, y += fs);
			setColor(0, 0, 0);
			drawString(fix(w[i]) + "cm", x, y += fs);
			drawString(fix(h[i]) + "cm", x, y += fs);
			
			if (i == 0) {
				y += fh / 8;
				drawString("]erƃCher̔r", x, y += fs);
			}
		}
	}
	String fix(int n) {
		if (n < 10)
			return "  " + n;
		if (n < 100)
			return " " + n;
		return "" + n;
	}
	//------------------------------------------------------------------
	// inchi[0], inchi[1]
	static final byte VERSION = (byte)1;
	void save() {
		byte[] b = new byte[3];
		b[0] = VERSION;
		b[1] = (byte)inch[0];
		b[2] = (byte)inch[1];
		writeSP(0, b);
	}
	void load() {
		byte[] b = readSP(0, 3);
		if (b[0] != VERSION) {
			inch[0] = 32;
			inch[1] = 36;
		} else {
			inch[0] = b[1] & 0xff;
			inch[1] = b[2] & 0xff;
		}
	}
}
